Index: common/multibyte.h
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/common/multibyte.h	Wed Aug 20 16:33:35 1997
***************
*** 0 ****
--- 1,224 ----
+ /*
+  * multilingual support for nvi
+  * Copyright(c) 1996, 1997 by Jun-ichiro Itoh.  All rights reserved.
+  * Author contact: <itojun@mt.cs.keio.ac.jp>
+  * $Id: multibyte.h,v 1.11 1997/08/20 07:33:35 itojun Exp $
+  *
+  * Freely redistributable, reusable, unless otherwise noted in accompanying
+  * document. (for example, redistribution is prohibited during alpha-test
+  * period)
+  * Absolutely no warranty.
+  *
+  * The code is based on:
+  *	jelvis japanization patch by Jun-ichiro Itoh
+  *	nvi 1.03 japanization patch by Yoshitaka Tokugawa <toku@dit.co.jp>
+  */
+ /*
+  * Misc entries that are publically available
+  */
+ 
+ /*
+  * check for various charsets.
+  */
+ #define	iseuckanji(c)	(0xa1 <= (c) && (c) <= 0xfe)
+ #define	issjiskanji1(c)	((0x81 <= (c) && (c) <= 0x9f) || (0xe0 <= (c) && (c) <= 0xfc))
+ #define	issjiskanji2(c)	((0x40 <= (c) && (c) <= 0x7e) || (0x80 <= (c) && (c) <= 0xfc))
+ #define isjishankana(c)	(0xa1 <= (c) && (c) <= 0xdf)
+ #define isbig5mb1(c)	(0xa1 <= (c) && (c) <= 0xfe)
+ #define	isbig5mb2(c)	((0x40 <= (c) && (c) <= 0x7e) || (0xa1 <= (c) && (c) <= 0xfe))
+ 
+ /*
+  * designation.
+  */
+ #define isecma(c)	(0x30 <= (c) && (c) <= 0x7f)
+ #define SO	'\016'
+ #define SI	'\017'
+ #define SS2	((u_char)'\216')
+ #define SS3	((u_char)'\217')
+ 
+ /*
+  * local type declarations.
+  */
+ enum _cstype { CS94, CS96, CS9494, CS9696 };
+ typedef enum _cstype CSTYPE;
+ 
+ struct _charset {
+ 	char	*name;		/* readable name */
+ 	int	blen;		/* length in buffer including flagbyte */
+ 	int	len;		/* width in appearance */
+ 
+ 	/* mostly generic */
+ 	u_int	(*chclass)();	/* function to get character class */
+ 	enum _cstype type;	/* size of charset: 94/96/94x94/96x96 */
+ 
+ 	/* specific to iso-2022-* */
+ 	char	enter;		/* last char of designation */
+ 	char	version;	/* version character */
+ 	char	oldstyle;	/* old style: ESC $ x not ESC $ ( x */
+ 	char	western;	/* western: need space between words */
+ };
+ typedef struct _charset CHARSET;
+ 
+ struct _encoding {
+ 	char	*name;
+ 	int	(*toint)();
+ 	int	(*fromint)();
+ 	void	(*keyinput)();
+ 	int	(*display)();
+ 
+ 	/* for iso-2022-* and euc-* */
+ 	CHAR_T	initg0;
+ 	CHAR_T	initg1;
+ 	CHAR_T	initg2;
+ 	CHAR_T	initg3;
+ 
+ 	/* for iso-2022-* */
+ 	int	maxcharset;	/* 1: G0 only  2: G0 and G1 ... */
+ 	int	maxside;	/* 1: GL only  2: GL and GR */
+ 	int	shifttype;	/* preferred shift type */
+ #define S_SI		0x0001	/*0F*/
+ #define S_SO		0x0002	/*0E*/
+ #define S_LS0		0x0001	/*0F*/
+ #define S_LS1		0x0002	/*0E*/
+ #define S_LS2		0x0004	/*ESC n*/
+ #define S_LS3		0x0008	/*ESC o*/
+ #define	S_SS2		0x0010	/*ESC N*/
+ #define	S_SS3		0x0020	/*ESC O*/
+ #define S_LS1R		0x0200	/*ESC ~*/
+ #define S_LS2R		0x0400	/*ESC }*/
+ #define S_LS3R		0x0800	/*ESC |*/
+ #define	S_SS2R		0x1000	/*8E*/
+ #define	S_SS3R		0x2000	/*8F*/
+ #define	S_NONE		0x0000
+ #define	S_0		0x0001
+ #define	S_1		0x0202
+ #define	S_2		0x1414
+ #define	S_3		0x2828
+ #define S_SEVEN_LOCK	0x000f
+ #define S_SEVEN_SINGLE	0x0030
+ #define S_SEVEN		0x003f
+ #define S_EIGHT_LOCK	0x0e00
+ #define S_EIGHT_SINGLE	0x3000
+ #define S_EIGHT		0x3e00
+ #define S_ALL		0x3e3f
+ #define S_EUC		0x3000
+ 	int	(*recommendation)();
+ 	int	flags;
+ #define	E_SOLRESET	0x0001	/* reset designation at begin of line */
+ #define	E_EOLRESET	0x0002	/* reset designations at end of line */
+ #define	E_NOOLDSTYLE	0x0004	/* should use ESC $ ( B for ESC $ [@AB] */
+ };
+ typedef struct _encoding ENCODING;
+ 
+ struct _iso2022state {
+ 	CHARSET const *charsets[4];
+ 	int	gl;
+ 	int	gr;
+ };
+ typedef struct _iso2022state ISO2022STATE;
+ 
+ /*
+  * multibyte flags.
+  */
+ #define MB_MULTIBYTE	0x01	/* conversion contains multibyte char */
+ #define	MB_SKIP		0x02	/* conversion contains unencodable char */
+ #define	MB_RAW		0x04	/* conversion ocntains raw binary char */
+ #define	MB_JOIN		0x08	/* should join the line to the next line */
+ 
+ /*
+  * global vars.
+  */
+ /* multibyte.c */
+ extern ENCODING const encodingtab[];
+ extern CHARSET const charsettab[];
+ 
+ /*
+  * function prototypes.
+  *
+  * We don't provide "PUBLIC:" comments since they shouldn't be reachable from
+  * other functions.
+  */
+ 
+ /* multibyte.c */
+ void multi_initstate __P((SCR *, ENCODING const *, ISO2022STATE *));
+ 
+ /* multi_chclass.c */
+ u_int jis0208_chclass __P((CHAR_T *, u_int));
+ u_int ksc5601_chclass __P((CHAR_T *, u_int));
+ 
+ /* multi_big5.c */
+ int big5_to_int __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int int_to_big5 __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ void big5_keyinput __P((SCR *, ENCODING const *, CHAR_T *, size_t, CHAR_T *, size_t *, int *, size_t *));
+ int big5_display __P((SCR *, ENCODING const *, CHAR_T *, CHAR_T *));
+ 
+ /* multi_euc.c */
+ #if 0
+ int euc_to_int __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int int_to_euc __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ #endif
+ int euc_recommendation __P((CHARSET const *, ENCODING const *));
+ #if 0
+ void euc_keyinput __P((SCR *, ENCODING const *, CHAR_T *, size_t, CHAR_T *, size_t *, int *, size_t *));
+ #endif
+ int euc_display __P((SCR *, ENCODING const *, CHAR_T *, CHAR_T *));
+ 
+ /* multi_eucjp.c */
+ #if 0
+ int int_to_eucjp __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ #endif
+ int eucjp_display __P((SCR *, ENCODING const *, CHAR_T *, CHAR_T *));
+ 
+ /* multi_euctw.c */
+ int euctw_to_int __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int int_to_euctw __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ void euctw_keyinput __P((SCR *, ENCODING const *, CHAR_T *, size_t, CHAR_T *, size_t *, int *, size_t *));
+ int euctw_display __P((SCR *, ENCODING const *, CHAR_T *, CHAR_T *));
+ 
+ /* multi_hz.c */
+ int hz_to_int __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int int_to_hz __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ 
+ /* multi_iso2022.c */
+ int iso2022_to_int __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int int_to_iso2022 __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int iso2022kr_to_int __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int int_to_iso2022kr __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int iso2022cn_recommendation __P((CHARSET const *, ENCODING const *));
+ int iso2022jp_recommendation __P((CHARSET const *, ENCODING const *));
+ int iso2022kr_recommendation __P((CHARSET const *, ENCODING const *));
+ int ctext_recommendation __P((CHARSET const *, ENCODING const *));
+ void iso2022_keyinput __P((SCR *, ENCODING const *, CHAR_T *, size_t, CHAR_T *, size_t *, int *, size_t *));
+ 
+ /* multi_none.c */
+ int none_to_int __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int int_to_none __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ void none_keyinput __P((SCR *, ENCODING const *, CHAR_T *, size_t, CHAR_T *, size_t *, int *, size_t *));
+ 
+ /* multi_sjis.c */
+ int sjis_to_int __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ int int_to_sjis __P((SCR *, ENCODING const *, CHAR_T *, size_t *, CHAR_T *, size_t, int *, ISO2022STATE *));
+ void sjis_keyinput __P((SCR *, ENCODING const *, CHAR_T *, size_t, CHAR_T *, size_t *, int *, size_t *));
+ int sjis_display __P((SCR *, ENCODING const *, CHAR_T *, CHAR_T *));
+ 
+ /* multi_quail.c */
+ void quail_keyinput __P((SCR *, ENCODING const *, CHAR_T *, size_t, CHAR_T *, size_t *, int *, size_t *));
+ 
+ #ifdef CANNA
+ /* multi_canna.c */
+ void canna_keyinput __P((SCR *, ENCODING const *, CHAR_T *, size_t, CHAR_T *, size_t *, int *, size_t *));
+ #endif
+ 
+ /*
+  * Charset id.
+  */
+ #define	CS_NONE		0x00
+ #define	CS_INVALID	0x01
+ #define CS_RAW(x)	(CS_RAW0 <= (x) && (x) <= CS_RAW7)
+ #include "multibyte_def.h"
+ 
+ #define	MAX_MULTI_BLEN	3
+ #define	MAX_MULTI_LEN	7
+ 
+ #define	ischarset(ch)	(((ch) & 0x80) && ((ch) < CS_MAX))
+ #define	charset(ch)	charsettab[(ch) & 0x7f]
Index: common/options.c
Prereq: 	10.51 
*** nvi-1.79/common/options.c	Tue Oct 15 03:56:29 1996
--- nvi-1.79-m17n/common/options.c	Thu Feb 20 00:40:55 1997
***************
*** 46,51 ****
--- 46,57 ----
  OPTLIST const optlist[] = {
  /* O_ALTWERASE	  4.4BSD */
  	{"altwerase",	f_altwerase,	OPT_0BOOL,	0},
+ /* O_AUTODETECT MULTIBYTE */
+ #ifdef MULTIBYTE
+ 	{"autodetect",	NULL,		OPT_STR,	0},
+ #else
+ 	{"autodetect",	NULL,		OPT_STR,	OPT_NDISP|OPT_NOSAVE},
+ #endif
  /* O_AUTOINDENT	    4BSD */
  	{"autoindent",	NULL,		OPT_0BOOL,	0},
  /* O_AUTOPRINT	    4BSD */
***************
*** 56,61 ****
--- 62,91 ----
  	{"backup",	NULL,		OPT_STR,	0},
  /* O_BEAUTIFY	    4BSD */
  	{"beautify",	NULL,		OPT_0BOOL,	0},
+ /* O_CANNA         CANNA */
+ #ifdef CANNA
+ 	{"canna",	f_canna,	OPT_0BOOL,	0},
+ #else
+ 	{"canna",	NULL,		OPT_0BOOL,	OPT_NDISP|OPT_NOSAVE|OPT_NOSET},
+ #endif
+ /* O_CANNACTRL     CANNA */
+ #ifdef CANNA
+ 	{"cannactrl",	NULL,		OPT_0BOOL,	0},
+ #else
+ 	{"cannactrl",	NULL,		OPT_0BOOL,	OPT_NDISP|OPT_NOSAVE|OPT_NOSET},
+ #endif
+ /* O_CANNAKEY      CANNA */
+ #ifdef CANNA
+ 	{"cannakey",	NULL,		OPT_STR,	0},
+ #else
+ 	{"cannakey",	NULL,		OPT_STR,	OPT_NDISP|OPT_NOSAVE},
+ #endif
+ /* O_CANNASERVER   CANNA */
+ #ifdef CANNA
+ 	{"cannaserver",	f_cannaserver,	OPT_STR,	0},
+ #else
+ 	{"cannaserver",	NULL,		OPT_STR,	OPT_NDISP|OPT_NOSAVE},
+ #endif
  /* O_CDPATH	  4.4BSD */
  	{"cdpath",	NULL,		OPT_STR,	0},
  /* O_CEDIT	  4.4BSD */
***************
*** 66,71 ****
--- 96,107 ----
  	{"comment",	NULL,		OPT_0BOOL,	0},
  /* O_DIRECTORY	    4BSD */
  	{"directory",	NULL,		OPT_STR,	0},
+ /* O_DISPLAYENCODING MULTIBYTE */
+ #ifdef MULTIBYTE
+ 	{"displayencoding",f_displayencoding,	OPT_STR,	0},
+ #else
+ 	{"displayencoding",NULL,	OPT_STR,	OPT_NDISP|OPT_NOSAVE},
+ #endif
  /* O_EDCOMPATIBLE   4BSD */
  	{"edcompatible",NULL,		OPT_0BOOL,	0},
  /* O_ESCAPETIME	  4.4BSD */
***************
*** 76,83 ****
--- 112,131 ----
  	{"exrc",	NULL,		OPT_0BOOL,	0},
  /* O_EXTENDED	  4.4BSD */
  	{"extended",	f_recompile,	OPT_0BOOL,	0},
+ /* O_FEPKEY    MULTIBYTE */
+ #ifdef MULTIBYTE
+ 	{"fepkey",	NULL,		OPT_STR,	0},
+ #else
+ 	{"fepkey",	NULL,		OPT_STR,	OPT_NDISP|OPT_NOSAVE},
+ #endif
  /* O_FILEC	  4.4BSD */
  	{"filec",	NULL,		OPT_STR,	0},
+ /* O_FILEENCODING MULTIBYTE */
+ #ifdef MULTIBYTE
+ 	{"fileencoding",f_fileencoding,	OPT_STR,	0},
+ #else
+ 	{"fileencoding", NULL,		OPT_STR,	OPT_NDISP|OPT_NOSAVE},
+ #endif
  /* O_FLASH	    HPUX */
  	{"flash",	NULL,		OPT_1BOOL,	0},
  /* O_HARDTABS	    4BSD */
***************
*** 86,91 ****
--- 134,145 ----
  	{"iclower",	f_recompile,	OPT_0BOOL,	0},
  /* O_IGNORECASE	    4BSD */
  	{"ignorecase",	f_recompile,	OPT_0BOOL,	0},
+ /* O_INPUTENCODING MULTIBYTE */
+ #ifdef MULTIBYTE
+ 	{"inputencoding",f_inputencoding,OPT_STR,	0},
+ #else
+ 	{"inputencoding", NULL,		OPT_STR,	OPT_NDISP|OPT_NOSAVE},
+ #endif
  /* O_KEYTIME	  4.4BSD */
  	{"keytime",	NULL,		OPT_NUM,	0},
  /* O_LEFTRIGHT	  4.4BSD */
***************
*** 173,178 ****
--- 227,238 ----
  	{"showmode",	NULL,		OPT_0BOOL,	0},
  /* O_SIDESCROLL	  4.4BSD */
  	{"sidescroll",	NULL,		OPT_NUM,	OPT_NOZERO},
+ /* O_SKIPDISPLAY MULTIBYTE */
+ #ifdef MULTIBYTE
+ 	{"skipdisplay",	f_reformat,	OPT_0BOOL,	0},
+ #else
+ 	{"skipdisplay",	f_reformat,	OPT_0BOOL,	OPT_NDISP|OPT_NOSAVE|OPT_NOSET},
+ #endif
  /* O_SLOWOPEN	    4BSD  */
  	{"slowopen",	NULL,		OPT_0BOOL,	0},
  /* O_SOURCEANY	    4BSD (undocumented)
***************
*** 235,251 ****
--- 295,323 ----
  } OABBREV;
  
  static OABBREV const abbrev[] = {
+ #ifdef MULTIBYTE
+ 	{"ad",		O_AUTODETECT},		/* MULTIBYTE */
+ #endif
  	{"ai",		O_AUTOINDENT},		/*     4BSD */
  	{"ap",		O_AUTOPRINT},		/*     4BSD */
  	{"aw",		O_AUTOWRITE},		/*     4BSD */
  	{"bf",		O_BEAUTIFY},		/*     4BSD */
  	{"co",		O_COLUMNS},		/*   4.4BSD */
  	{"dir",		O_DIRECTORY},		/*     4BSD */
+ #ifdef MULTIBYTE
+ 	{"de",		O_DISPLAYENCODING},	/* MULTIBYTE */
+ #endif
  	{"eb",		O_ERRORBELLS},		/*     4BSD */
  	{"ed",		O_EDCOMPATIBLE},	/*     4BSD */
  	{"ex",		O_EXRC},		/* System V (undocumented) */
+ #ifdef MULTIBYTE
+ 	{"fe",		O_FILEENCODING},	/* MULTIBYTE */
+ #endif
  	{"ht",		O_HARDTABS},		/*     4BSD */
  	{"ic",		O_IGNORECASE},		/*     4BSD */
+ #ifdef MULTIBYTE
+ 	{"ie",		O_INPUTENCODING},	/* MULTIBYTE */
+ #endif
  	{"li",		O_LINES},		/*   4.4BSD */
  	{"modelines",	O_MODELINE},		/*     HPUX */
  	{"nu",		O_NUMBER},		/*     4BSD */
***************
*** 254,259 ****
--- 326,334 ----
  	{"re",		O_REDRAW},		/* O'Reilly */
  	{"ro",		O_READONLY},		/*     4BSD (undocumented) */
  	{"scr",		O_SCROLL},		/*     4BSD (undocumented) */
+ #ifdef MULTIBYTE
+ 	{"sd",		O_SKIPDISPLAY},		/* MULTIBYTE */
+ #endif
  	{"sect",	O_SECTIONS},		/* O'Reilly */
  	{"sh",		O_SHELL},		/*     4BSD */
  	{"slow",	O_SLOWOPEN},		/*     4BSD */
***************
*** 325,330 ****
--- 400,418 ----
  	if (o_set(sp, O_SECURE, 0, NULL, GO_SECURE))
  		goto err;
  	F_SET(&sp->opts[O_SECURE], OPT_GLOBAL);
+ #ifdef MULTIBYTE
+ 	if (o_set(sp, O_DISPLAYENCODING, 0, NULL, GO_DISPLAYENCODING))
+ 		goto err;
+ 	F_SET(&sp->opts[O_DISPLAYENCODING], OPT_GLOBAL);
+ #endif /*MULTIBYTE*/
+ #ifdef CANNA
+ 	if (o_set(sp, O_CANNA, 0, NULL, GO_CANNA))
+ 		goto err;
+ 	F_SET(&sp->opts[O_CANNA], OPT_GLOBAL);
+ 	if (o_set(sp, O_CANNASERVER, 0, NULL, GO_CANNASERVER))
+ 		goto err;
+ 	F_SET(&sp->opts[O_CANNASERVER], OPT_GLOBAL);
+ #endif /*CANNA*/
  
  	/* Initialize string values. */
  	(void)snprintf(b1, sizeof(b1),
***************
*** 362,367 ****
--- 450,470 ----
  	OI(O_TABSTOP, "tabstop=8");
  	(void)snprintf(b1, sizeof(b1), "tags=%s", _PATH_TAGS);
  	OI(O_TAGS, b1);
+ #ifdef MULTIBYTE
+ 	OI(O_FEPKEY, "fepkey=/?aioAIO");
+ 	(void)snprintf(b1, sizeof(b1), "autodetect=%s", "off");
+ 	OI(O_FILEENCODING, b1);
+ 	(void)snprintf(b1, sizeof(b1), "displayencoding=%s", DEFAULT_ENCODING);
+ 	OI(O_DISPLAYENCODING, b1);
+ 	(void)snprintf(b1, sizeof(b1), "fileencoding=%s", DEFAULT_ENCODING);
+ 	OI(O_FILEENCODING, b1);
+ 	(void)snprintf(b1, sizeof(b1), "inputencoding=%s", DEFAULT_ENCODING);
+ 	OI(O_INPUTENCODING, b1);
+ #endif /*MULTIBYTE*/
+ #ifdef CANNA
+ 	(void)snprintf(b1, sizeof(b1), "cannakey=%c", 'O' & 0x1f);
+ 	OI(O_CANNAKEY, b1);
+ #endif
  
  	/*
  	 * XXX
***************
*** 450,457 ****
--- 553,567 ----
  	OPTLIST const *op;
  	OPTION *spo;
  	u_long value, turnoff;
+ #ifndef MULTIBYTE
  	int ch, equals, nf, nf2, offset, qmark, rval;
  	char *endp, *name, *p, *sep, *t;
+ #else
+ 	CHAR_T ch;
+ 	int equals, nf, nf2, offset, qmark, rval;
+ 	char *name, *p, *t;
+ 	CHAR_T *endp, *sep;
+ #endif
  
  	disp = NO_DISPLAY;
  	for (rval = 0; argv[0]->len != 0; ++argv) {
Index: common/options_f.c
Prereq: 	10.25 
*** nvi-1.79/common/options_f.c	Sat Jul 13 07:23:37 1996
--- nvi-1.79-m17n/common/options_f.c	Sun Feb  2 04:18:00 1997
***************
*** 365,367 ****
--- 365,516 ----
  		*valp = 1;
  	return (0);
  }
+ 
+ #ifdef MULTIBYTE
+ /*
+  * PUBLIC: #ifdef MULTIBYTE
+  * PUBLIC: int f_fileencoding __P((SCR *, OPTION *, char *, u_long *));
+  * PUBLIC: #endif
+  */
+ int
+ f_fileencoding(sp, op, str, valp)
+ 	SCR *sp;
+ 	OPTION *op;
+ 	char *str;
+ 	u_long *valp;
+ {
+ 	int nf, nf2;
+ 	char *p, *t;
+ 	char keep;
+ 	size_t len;
+ 
+ 	if (multi_isencoding(str, O_FILEENCODING))
+ 		return 0;
+ 			
+ 	p = msg_print(sp, "fileencoding", &nf);
+ 	t = msg_print(sp, "illegal value", &nf2);
+ 	msgq(sp, M_ERR, "036|set: %s option: %s", p, t);
+ 	if (nf)
+ 		FREE_SPACE(sp, p, 0);
+ 	if (nf2)
+ 		FREE_SPACE(sp, t, 0);
+ 	return 1;
+ }
+ 
+ /*
+  * PUBLIC: #ifdef MULTIBYTE
+  * PUBLIC: int f_displayencoding __P((SCR *, OPTION *, char *, u_long *));
+  * PUBLIC: #endif
+  */
+ int
+ f_displayencoding(sp, op, str, valp)
+ 	SCR *sp;
+ 	OPTION *op;
+ 	char *str;
+ 	u_long *valp;
+ {
+ 	int nf, nf2;
+ 	char *p, *t;
+ 
+ 	if (multi_isencoding(str, O_DISPLAYENCODING)) {
+ 		/*
+ 		 * We need to redraw the entire screen.
+ 		 */
+ 		F_SET(sp, SC_SCR_REFORMAT);
+ 		return 0;
+ 	}
+ 
+ 	p = msg_print(sp, "displayencoding", &nf);
+ 	t = msg_print(sp, "illegal value", &nf2);
+ 	msgq(sp, M_ERR, "036|set: %s option: %s", p, t);
+ 	if (nf)
+ 		FREE_SPACE(sp, p, 0);
+ 	if (nf2)
+ 		FREE_SPACE(sp, t, 0);
+ 	return 1;
+ }
+ 
+ /*
+  * PUBLIC: #ifdef MULTIBYTE
+  * PUBLIC: int f_inputencoding __P((SCR *, OPTION *, char *, u_long *));
+  * PUBLIC: #endif
+  */
+ int
+ f_inputencoding(sp, op, str, valp)
+ 	SCR *sp;
+ 	OPTION *op;
+ 	char *str;
+ 	u_long *valp;
+ {
+ 	int nf, nf2;
+ 	char *p, *t;
+ 
+ 	if (multi_isencoding(str, O_INPUTENCODING)) {
+ 		multi_keyinput_resetstate(sp);
+ 		return 0;
+ 	}
+ 
+ 	p = msg_print(sp, "inputencoding", &nf);
+ 	t = msg_print(sp, "illegal value", &nf2);
+ 	msgq(sp, M_ERR, "036|set: %s option: %s", p, t);
+ 	if (nf)
+ 		FREE_SPACE(sp, p, 0);
+ 	if (nf2)
+ 		FREE_SPACE(sp, t, 0);
+ 	return 1;
+ }
+ #endif /*MULTIBYTE*/
+ 
+ #ifdef CANNA
+ /*
+  * PUBLIC: #ifdef CANNA
+  * PUBLIC: int f_canna __P((SCR *, OPTION *, char *, u_long *));
+  * PUBLIC: #endif
+  */
+ int
+ f_canna(sp, op, str, valp)
+ 	SCR *sp;
+ 	OPTION *op;
+ 	char *str;
+ 	u_long *valp;
+ {
+ 	int nf, nf2;
+ 	char *p, *t;
+ 
+ 	/*
+ 	 * Note that *valp means "turning off".
+ 	 */
+ 	if (!*valp) {
+ 		if (canna_init(sp))
+ 			goto err;
+ 	} else
+ 		canna_end(sp);
+ 	return 0;
+ 
+ err:;
+ 	p = msg_print(sp, "canna", &nf);
+ 	t = msg_print(sp, "canna not available", &nf2);
+ 	msgq(sp, M_ERR, "036|set: %s option: %s", p, t);
+ 	if (nf)
+ 		FREE_SPACE(sp, p, 0);
+ 	if (nf2)
+ 		FREE_SPACE(sp, t, 0);
+ 	return 1;
+ }
+ 
+ /*
+  * PUBLIC: #ifdef CANNA
+  * PUBLIC: int f_cannaserver __P((SCR *, OPTION *, char *, u_long *));
+  * PUBLIC: #endif
+  */
+ int
+ f_cannaserver(sp, op, str, valp)
+ 	SCR *sp;
+ 	OPTION *op;
+ 	char *str;
+ 	u_long *valp;
+ {
+ 	canna_setserver(sp, str);
+ 	return 0;
+ }
+ #endif /*CANNA*/
Index: common/put.c
Prereq: 	10.11 
*** nvi-1.79/common/put.c	Tue Sep 24 08:34:18 1996
--- nvi-1.79-m17n/common/put.c	Fri Feb 21 23:06:33 1997
***************
*** 45,50 ****
--- 45,53 ----
  	size_t blen, clen, len;
  	int rval;
  	char *bp, *p, *t;
+ #ifdef MULTIBYTE
+ 	CHAR_T *p0;
+ #endif
  
  	if (cbp == NULL)
  		if (namep == NULL) {
***************
*** 119,130 ****
  	lno = cp->lno;
  	if (db_get(sp, lno, DBG_FATAL, &p, &len))
  		return (1);
  
  	GET_SPACE_RET(sp, bp, blen, tp->len + len + 1);
  	t = bp;
  
  	/* Original line, left of the split. */
! 	if (len > 0 && (clen = cp->cno + (append ? 1 : 0)) > 0) {
  		memcpy(bp, p, clen);
  		p += clen;
  		t += clen;
--- 122,141 ----
  	lno = cp->lno;
  	if (db_get(sp, lno, DBG_FATAL, &p, &len))
  		return (1);
+ #ifdef MULTIBYTE
+ 	p0 = p;
+ #endif
  
  	GET_SPACE_RET(sp, bp, blen, tp->len + len + 1);
  	t = bp;
  
  	/* Original line, left of the split. */
! #ifndef MULTIBYTE
! 	if (len > 0 && (clen = cp->cno + (append ? 1 : 0)) > 0)
! #else
! 	if (len > 0 && (clen = cp->cno + (append ? KEY_BLEN(sp, p0[cp->cno]) : 0)) > 0)
! #endif
! 	{
  		memcpy(bp, p, clen);
  		p += clen;
  		t += clen;
***************
*** 137,143 ****
--- 148,158 ----
  	}
  
  	/* Calculate length left in the original line. */
+ #ifndef MULTIBYTE
  	clen = len == 0 ? 0 : len - (cp->cno + (append ? 1 : 0));
+ #else
+ 	clen = len == 0 ? 0 : len - (cp->cno + (append ? KEY_BLEN(sp, p0[cp->cno]) : 0));
+ #endif
  
  	/*
  	 * !!!
***************
*** 153,159 ****
--- 168,178 ----
  	 * behavior, and expect POSIX.2 to do so as well.
  	 */
  	rp->lno = lno;
+ #ifndef MULTIBYTE
  	rp->cno = len == 0 ? 0 : sp->cno + (append && tp->len ? 1 : 0);
+ #else
+ 	rp->cno = len == 0 ? 0 : sp->cno + (append && tp->len ? KEY_BLEN(sp, p0[sp->cno]) : 0);
+ #endif
  
  	/*
  	 * If no more lines in the CB, append the rest of the original
Index: common/screen.h
Prereq: 	10.24 
*** nvi-1.79/common/screen.h	Wed Oct 23 22:31:07 1996
--- nvi-1.79-m17n/common/screen.h	Fri Feb 21 22:59:27 1997
***************
*** 119,130 ****
--- 119,142 ----
  					/* Ex/vi: RE information. */
  	dir_t	 searchdir;		/* Last file search direction. */
  	regex_t	 re_c;			/* Search RE: compiled form. */
+ #ifndef MULTIBYTE
  	char	*re;			/* Search RE: uncompiled form. */
+ #else
+ 	CHAR_T	*re;			/* Search RE: uncompiled form. */
+ #endif
  	size_t	 re_len;		/* Search RE: uncompiled length. */
  	regex_t	 subre_c;		/* Substitute RE: compiled form. */
+ #ifndef MULTIBYTE
  	char	*subre;			/* Substitute RE: uncompiled form. */
+ #else
+ 	CHAR_T	*subre;			/* Substitute RE: uncompiled form. */
+ #endif
  	size_t	 subre_len;		/* Substitute RE: uncompiled length). */
+ #ifndef MULTIBYTE
  	char	*repl;			/* Substitute replacement. */
+ #else
+ 	CHAR_T	*repl;			/* Substitute replacement. */
+ #endif
  	size_t	 repl_len;		/* Substitute replacement length.*/
  	size_t	*newl;			/* Newline offset array. */
  	size_t	 newl_len;		/* Newline array size. */
Index: common/search.c
Prereq: 	10.25 
*** nvi-1.79/common/search.c	Mon Jul  1 05:12:50 1996
--- nvi-1.79-m17n/common/search.c	Fri Feb 21 23:07:12 1997
***************
*** 46,52 ****
--- 46,57 ----
  {
  	recno_t lno;
  	int delim;
+ #ifndef MULTIBYTE
  	char *p, *t;
+ #else
+ 	char *t;
+ 	CHAR_T *p;
+ #endif
  
  	/* If the file is empty, it's a fast search. */
  	if (sp->lno <= 1) {
***************
*** 114,119 ****
--- 119,137 ----
  				++p;
  				--plen;
  			}
+ #ifdef MULTIBYTE
+ 		    {
+ 			size_t advance;
+ 
+ 			if (1 < (advance = KEY_BLEN(sp, *p))) {
+ 				advance--;
+ 				while (advance--) {
+ 					*t++ = *p++;
+ 					plen--;
+ 				}
+ 			}
+ 		    }
+ #endif /*MULTIBYTE*/
  		}
  		if (epp != NULL)
  			*epp = p;
***************
*** 156,162 ****
--- 174,184 ----
  	regmatch_t match[1];
  	size_t coff, len;
  	int cnt, eval, rval, wrapped;
+ #ifndef MULTIBYTE
  	char *l;
+ #else
+ 	CHAR_T *l;
+ #endif
  
  	if (search_init(sp, FORWARD, ptrn, plen, eptrn, flags))
  		return (1);
***************
*** 195,202 ****
  				}
  				lno = 1;
  			}
! 		} else
  			coff = fm->cno + 1;
  	}
  
  	btype = BUSY_ON;
--- 217,229 ----
  				}
  				lno = 1;
  			}
! 		} else {
! #ifndef MULTIBYTE
  			coff = fm->cno + 1;
+ #else
+ 			coff = fm->cno + KEY_BLEN(sp, l[fm->cno]);
+ #endif
+ 		}
  	}
  
  	btype = BUSY_ON;
***************
*** 268,275 ****
  		 * "c?$<cr>").  Not all that sure this gets it right, there
  		 * are lots of strange cases.
  		 */
! 		if (!LF_ISSET(SEARCH_EOL) && rm->cno >= len)
  			rm->cno = len != 0 ? len - 1 : 0;
  
  		rval = 0;
  		break;
--- 295,309 ----
  		 * "c?$<cr>").  Not all that sure this gets it right, there
  		 * are lots of strange cases.
  		 */
! 		if (!LF_ISSET(SEARCH_EOL) && rm->cno >= len) {
! #ifndef MULTIBYTE
  			rm->cno = len != 0 ? len - 1 : 0;
+ #else
+ 			rm->cno = len != 0
+ 					? len - multi_back(sp, l, &l[len])
+ 					: 0;
+ #endif /*MULTIBYTE*/
+ 		}
  
  		rval = 0;
  		break;
***************
*** 318,323 ****
--- 352,360 ----
  	if (LF_ISSET(SEARCH_INCR)) {
  		lno = fm->lno;
  		coff = fm->cno + 1;
+ #ifdef MULTIBYTE
+ 		/* the statement is multibyte safe. (see the comment above) */
+ #endif
  	} else {
  		if (fm->cno == 0) {
  			if (fm->lno == 1 && !O_ISSET(sp, O_WRAPSCAN)) {
***************
*** 429,437 ****
  		rm->lno = lno;
  
  		/* See comment in f_search(). */
! 		if (!LF_ISSET(SEARCH_EOL) && last >= len)
  			rm->cno = len != 0 ? len - 1 : 0;
! 		else
  			rm->cno = last;
  		rval = 0;
  		break;
--- 466,479 ----
  		rm->lno = lno;
  
  		/* See comment in f_search(). */
! 		if (!LF_ISSET(SEARCH_EOL) && last >= len) {
! #ifndef MULTIBYTE
  			rm->cno = len != 0 ? len - 1 : 0;
! #else
! 			rm->cno = len != 0
! 					? len - multi_back(sp, l, &l[len]) : 0;
! #endif /*MULTIBYTE*/
! 		} else
  			rm->cno = last;
  		rval = 0;
  		break;
Index: common/seq.c
Prereq: 	10.10 
*** nvi-1.79/common/seq.c	Sun Apr 28 00:25:59 1996
--- nvi-1.79-m17n/common/seq.c	Thu Feb 20 00:41:29 1997
***************
*** 342,348 ****
--- 342,352 ----
  	CHAR_T *p;
  	SEQ *qp;
  	size_t olen;
+ #ifndef MULTIBYTE
  	int ch;
+ #else
+ 	CHAR_T ch;
+ #endif
  
  	/* Write a sequence command for all keys the user defined. */
  	for (qp = sp->gp->seqq.lh_first; qp != NULL; qp = qp->q.le_next) {
